## emscripten 1.22.1

=== tests/box2d/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(Box2D)

if(UNIX)
	set(BOX2D_INSTALL_BY_DEFAULT ON)
else(UNIX)
	set(BOX2D_INSTALL_BY_DEFAULT OFF)
endif(UNIX)

option(BOX2D_INSTALL "Install Box2D libs, includes, and CMake scripts" ${BOX2D_INSTALL_BY_DEFAULT})
option(BOX2D_INSTALL_DOC "Install Box2D documentation" OFF)
option(BOX2D_BUILD_SHARED "Build Box2D shared libraries" OFF)
option(BOX2D_BUILD_STATIC "Build Box2D static libraries" ON)
option(BOX2D_BUILD_EXAMPLES "Build Box2D examples" ON)

set(BOX2D_VERSION 2.1.0)

# The Box2D library.
add_subdirectory(Box2D)

if(BOX2D_BUILD_EXAMPLES)
  # HelloWorld console example.
  add_subdirectory(HelloWorld)

  # Testbed and dependencies.
  find_package(OpenGL REQUIRED)
  add_subdirectory(freeglut)
  add_subdirectory(glui)
  add_subdirectory(Testbed)
endif(BOX2D_BUILD_EXAMPLES)

if(BOX2D_INSTALL_DOC)
  install(DIRECTORY Documentation DESTINATION share/doc/Box2D PATTERN ".svn" EXCLUDE)
endif(BOX2D_INSTALL_DOC)

=== tests/cube2hash/Makefile ===
all: cube2hash.bc

cube2hash.bc: cube2crypto.o tiger.o hashstring.o
	$(CXX) $^ -o $@

hashstring.o: hashstring.cpp
	$(CXX) -c $^ -o $@

cube2crypto.o: cube2crypto.c cube2crypto.h
	$(CC) -c $< -o $@

tiger.o: tiger.c tiger.h
	$(CC) -c $< -o $@

=== tests/freealut/CMakeLists.txt ===
# cmake project file by Prakash Punnoor
CMAKE_MINIMUM_REQUIRED(VERSION 2.0)

SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/admin/CMakeModules")
PROJECT(Alut C)
SET(PACKAGE "freealut")
SET(PACKAGE_TARNAME "freealut")
SET(PACKAGE_NAME "freealut library")
SET(PACKAGE_MAJOR_VERSION "1")
SET(PACKAGE_MINOR_VERSION "0")
SET(PACKAGE_BUILD_VERSION "1")
SET(PACKAGE_VERSION "${PACKAGE_MAJOR_VERSION}.${PACKAGE_MINOR_VERSION}.${PACKAGE_BUILD_VERSION}")
SET(MAJOR_VERSION "0")
SET(MINOR_VERSION "0")
SET(BUILD_VERSION "0")
SET(VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${BUILD_VERSION}")
SET(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
SET(PACKAGE_BUGREPORT "openal-devel@opensource.creative.com")
SET(OPERATING_SYSTEM "${CMAKE_SYSTEM_NAME}")

INCLUDE(${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
INCLUDE(${CMAKE_ROOT}/Modules/CheckIncludeFiles.cmake)
INCLUDE(${CMAKE_ROOT}/Modules/CheckCSourceCompiles.cmake)

FIND_PACKAGE(ConfigHelper)

SET(ALUT_SOURCES src/alutBufferData.c
                 src/alutCodec.c
                 src/alutError.c
                 src/alutInit.c
                 src/alutInputStream.c
                 src/alutInternal.h
                 src/alutLoader.c
                 src/alutOutputStream.c
                 src/alutUtil.c
                 src/alutVersion.c
                 src/alutWaveform.c)

INCLUDE_DIRECTORIES(${Alut_SOURCE_DIR}/include)

SET(ADD_WFLAGS "")
SET(ADD_CFLAGS "")
SET(ADD_LDFLAGS "")
SET(ADD_LIBS "")

OPTION(BUILD_STATIC    "build static library too"   ON)
OPTION(PROFILE         "enable profile"            OFF)
OPTION(OPTIMIZATION    "enable optimization"        ON)
OPTION(WARNINGS        "enable warnings"            ON)
IF(WARNINGS)
  OPTION(MORE_WARNINGS "enable more warnings"       OFF)
  OPTION(USE_WERROR    "enable fail on all warning" OFF)
ENDIF(WARNINGS)

#want test-suit?
OPTION(BUILD_TESTS "build the test-suite" OFF)


ADD_DEFINE(ALUT_BUILD_LIBRARY)
# We could possibly need struct timespec and random(), which are not ANSI.
# Define to 500 if Single Unix conformance is wanted, 600 for sixth revision.
ADD_DEFINE("_XOPEN_SOURCE 500")
# We might need nanosleep, which is a POSIX IEEE Std 1003.1b-1993 feature.
# Define to the POSIX version that should be used.
ADD_DEFINE("_POSIX_C_SOURCE 199309")
# Without __NO_CTYPE tolower and friends are macros which introduce a GLIBC 2.3
# dependency. By defining this identifier we are currently backwards compatible
# to GLIBC 2.1.3, which is a good thing. In addition, the macros lead to code
# which triggers warnings with -Wunreachable-code.
ADD_DEFINE("__NO_CTYPE 1")

ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DNDEBUG)

if (EMSCRIPTEN)
  # Emscripten cannot use FIND_LIBRARY, since that seaches for linkable library files, but Emscripten supports
  # OpenAL in core and there are no library files to link against. Instead, use a custom OpenAL package finder
  # provided by Emscripten.
  FIND_PACKAGE(OpenAL)

  # All the include file checks bloew are no-ops for Emscripten, so for that platform, just define the flags we support.
  SET(HAVE_STDINT_H 1)
  SET(HAVE_STAT 1)
  SET(HAVE_NANOSLEEP 1)
  SET(HAVE_TIME_H 1)
  ADD_DEFINITIONS(-DHAVE_STDINT_H=1 -DHAVE_STAT=1 -DHAVE_NANOSLEEP=1 -DHAVE_TIME_H=1)
  SET(CMAKE_EXECUTABLE_SUFFIX ".bc")
else()
  FIND_LIBRARY(OPENAL_LIB NAMES openal openal32 PATHS /usr/lib /usr/local/lib ${OPENAL_LIB_DIR})

  IF(OPENAL_LIB MATCHES "NOTFOUND")
    MESSAGE(FATAL_ERROR "OpenAL not installed, cannot build alut - aborting.")
  ENDIF(OPENAL_LIB MATCHES "NOTFOUND")

  IF(UNIX)
    SET(ADD_LIBS ${ADD_LIBS} m)
  ENDIF(UNIX)
endif()

SET(CMAKE_REQUIRED_INCLUDES ${OPENAL_INCLUDE_DIR})

if (NOT EMSCRIPTEN) # Emscripten is a cross-compiler and cannot verify paths of include files with CHECK_INCLUDE_FILES, since that requires building native executables.
  CHECK_INCLUDE_FILES("AL/alc.h;AL/al.h" AL_HEADERS)
  IF(NOT AL_HEADERS)
    MESSAGE(FATAL_ERROR "OpenAL header files not found - aborting.")
  ENDIF(NOT AL_HEADERS)
endif()

IF(DEFINED OPENAL_INCLUDE_DIR)
  INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIR})
ENDIF(DEFINED OPENAL_INCLUDE_DIR)

FIND_PACKAGE(SleepFunction)

CHECK_INCLUDE_FILE_DEFINE(stdint.h HAVE_STDINT_H)

IF(WIN32)
  CHECK_INCLUDE_FILE_DEFINE(basetsd.h HAVE_BASETSD_H)
ENDIF(WIN32)

# FindSleepFunction will check for unistd.h if time.h wasn't found
IF(HAVE_TIME_H)
  CHECK_INCLUDE_FILE_DEFINE(unistd.h HAVE_UNISTD_H)
ENDIF(HAVE_TIME_H)

IF(HAVE_UNISTD_H)
  CHECK_FUNCTION_DEFINE("
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <unistd.h>
  " stat "(\"\", (struct stat*)0)" HAVE_STAT)
ENDIF(HAVE_UNISTD_H)

IF(NOT HAVE_STAT)
  CHECK_FUNCTION_DEFINE("
  #include <sys/types.h>
  #include <sys/stat.h>
  " _stat "(\"\", (struct _stat*)0)" HAVE__STAT)
ENDIF(NOT HAVE_STAT)

# compiler specific settings
FIND_PACKAGE(CompilerAttribute)
FIND_PACKAGE(CompilerVisibility)
FIND_PACKAGE(CompilerFlagsSet)

GENERATE_CONFIG_H()

SET(CMAKE_C_FLAGS "${ADD_WFLAGS} ${ADD_CFLAGS} ${CMAKE_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "${ADD_CFLAGS} ${CMAKE_CXX_FLAGS}")
SET(CMAKE_SHARED_LINKER_FLAGS "${ADD_LDFLAGS} ${CMAKE_SHARED_LINKER_FLAGS}")
SET(CMAKE_MODULE_LINKER_FLAGS "${ADD_LDFLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")

IF(BUILD_STATIC)
  # we can't create a static library with the same name
  # as the shared one, so we copy it over after creation
  ADD_LIBRARY(alut_static STATIC ${ALUT_SOURCES})
  TARGET_LINK_LIBRARIES(alut_static ${OPENAL_LIB} ${ADD_LIBS})
  IF(NOT WIN32)
    ADD_CUSTOM_COMMAND(
      TARGET alut_static
      POST_BUILD
      COMMAND ${CMAKE_COMMAND}
      ARGS -E copy
        ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut_static${CMAKE_STATIC_LIBRARY_SUFFIX}
        ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
    INSTALL_FILES(/lib FILES ${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
  ENDIF(NOT WIN32)
ENDIF(BUILD_STATIC)


ADD_LIBRARY(alut SHARED ${ALUT_SOURCES})
SET_TARGET_PROPERTIES(alut PROPERTIES VERSION ${VERSION} SOVERSION ${MAJOR_VERSION})
TARGET_LINK_LIBRARIES(alut ${OPENAL_LIB} ${ADD_LIBS})

INSTALL_TARGETS(/lib alut)
INSTALL_FILES(/include/AL FILES include/AL/alut.h)

# needed for openal.pc.in and openal-config.in
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(exec_prefix "\${prefix}")
SET(libdir "\${exec_prefix}/lib")
SET(bindir "\${exec_prefix}/bin")
SET(includedir "\${prefix}/include")
SET(requirements "")
# static linking dependecies are broken, so pthread isn't needed currently
SET(PTHREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/admin/pkgconfig/freealut.pc.in
               ${CMAKE_BINARY_DIR}/admin/pkgconfig/freealut.pc @ONLY)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/admin/pkgconfig/freealut-config.in
               ${CMAKE_BINARY_DIR}/admin/pkgconfig/freealut-config @ONLY)
INSTALL_PROGRAMS(/bin FILES admin/pkgconfig/freealut-config)
INSTALL_FILES(/lib/pkgconfig FILES admin/pkgconfig/freealut.pc)


# test-suite
IF(BUILD_TESTS)
    # examples
    ADD_EXECUTABLE(hello_world examples/hello_world.c)
    if (EMSCRIPTEN)
      TARGET_LINK_LIBRARIES(hello_world ${OPENAL_LIB} ${ADD_LIBS} alut_static)
    else()
      TARGET_LINK_LIBRARIES(hello_world ${OPENAL_LIB} ${ADD_LIBS} alut)
    endif()

    ADD_EXECUTABLE(playfile examples/playfile.c)
    if (EMSCRIPTEN)
      TARGET_LINK_LIBRARIES(playfile ${OPENAL_LIB} ${ADD_LIBS} alut_static)
    else()
      TARGET_LINK_LIBRARIES(playfile ${OPENAL_LIB} ${ADD_LIBS} alut)
    endif()


    SET(TESTS errorstuff
              fileloader
              memoryloader
              version
              waveforms)

    FOREACH(TEST ${TESTS})
      SET(TEST_SRC test_suite/test_${TEST}.c)
      SET_SOURCE_FILES_PROPERTIES(${TEST_SRC} PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
      ADD_EXECUTABLE(test_${TEST} ${TEST_SRC})
      TARGET_LINK_LIBRARIES(test_${TEST} ${OPENAL_LIB} ${ADD_LIBS} alut)
    ENDFOREACH(TEST)

    #copy over testdata, so test-suite can be used in binary dir
    SET(TESTDATA file1.wav
                 file2.au
                 file3.raw)

    FOREACH(TESTDATUM ${TESTDATA})
      CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/test_suite/${TESTDATUM} ${CMAKE_BINARY_DIR}/${TESTDATUM} COPYONLY)
    ENDFOREACH(TESTDATUM)
ENDIF(BUILD_TESTS)

=== tests/glbook/Makefile ===
# Straight forward Makefile to compile all examples in a row

INCDIR=-I./Common
LIBS=-lGLESv2 -lEGL -lm -lX11

COMMONSRC=./Common/esShader.c    \
          ./Common/esTransform.c \
          ./Common/esShapes.c    \
          ./Common/esUtil.c
COMMONHRD=esUtil.h

CH02SRC=./Chapter_2/Hello_Triangle/Hello_Triangle.c
CH08SRC=./Chapter_8/Simple_VertexShader/Simple_VertexShader.c
CH09SRC1=./Chapter_9/Simple_Texture2D/Simple_Texture2D.c
CH09SRC2=./Chapter_9/MipMap2D/MipMap2D.c
CH09SRC3=./Chapter_9/Simple_TextureCubemap/Simple_TextureCubemap.c
CH09SRC4=./Chapter_9/TextureWrap/TextureWrap.c
CH10SRC=./Chapter_10/MultiTexture/MultiTexture.c
CH11SRC=./Chapter_11/Multisample/Multisample.c
CH11SRC2=./Chapter_11/Stencil_Test/Stencil_Test.c
CH13SRC2=./Chapter_13/ParticleSystem/ParticleSystem.c

default: all

all: ./Chapter_2/Hello_Triangle/CH02_HelloTriangle.bc \
     ./Chapter_8/Simple_VertexShader/CH08_SimpleVertexShader.bc \
     ./Chapter_9/Simple_Texture2D/CH09_SimpleTexture2D.bc \
     ./Chapter_9/MipMap2D/CH09_MipMap2D.bc \
     ./Chapter_9/Simple_TextureCubemap/CH09_TextureCubemap.bc \
     ./Chapter_9/TextureWrap/CH09_TextureWrap.bc \
     ./Chapter_10/MultiTexture/CH10_MultiTexture.bc \
     ./Chapter_13/ParticleSystem/CH13_ParticleSystem.bc
#     ./Chapter_11/Multisample/CH11_Multisample.bc \
#     ./Chapter_11/Stencil_Test/CH11_Stencil_Test.bc \

clean:
	find . -name "CH??_*" | xargs rm -f

./Chapter_2/Hello_Triangle/CH02_HelloTriangle.bc: ${COMMONSRC} ${COMMONHDR} ${CH02SRC}
	$(CC) ${COMMONSRC} ${CH02SRC} -o $@ ${INCDIR} ${LIBS}
./Chapter_8/Simple_VertexShader/CH08_SimpleVertexShader.bc: ${COMMONSRC} ${COMMONHDR} ${CH08SRC}
	$(CC) ${COMMONSRC} ${CH08SRC} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_9/Simple_Texture2D/CH09_SimpleTexture2D.bc: ${COMMONSRC} ${COMMONHDR} ${CH09SRC1}
	$(CC) ${COMMONSRC} ${CH09SRC1} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_9/MipMap2D/CH09_MipMap2D.bc: ${COMMONSRC} ${COMMONHDR} ${CH09SRC2}
	$(CC) ${COMMONSRC} ${CH09SRC2} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_9/Simple_TextureCubemap/CH09_TextureCubemap.bc: ${COMMONSRC} ${COMMONHDR} ${CH09SRC3}
	$(CC) ${COMMONSRC} ${CH09SRC3} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_9/TextureWrap/CH09_TextureWrap.bc: ${COMMONSRC} ${COMMONHDR} ${CH09SRC4}
	$(CC) ${COMMONSRC} ${CH09SRC4} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_10/MultiTexture/CH10_MultiTexture.bc: ${COMMONSRC} ${COMMONHDR} ${CH10SRC}
	$(CC) ${COMMONSRC} ${CH10SRC} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_11/Multisample/CH11_Multisample.bc: ${COMMONSRC} ${COMMONHDR} ${CH11SRC}
	$(CC) ${COMMONSRC} ${CH11SRC} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_11/Stencil_Test/CH11_Stencil_Test.bc: ${COMMONSRC} ${COMMONHDR} ${CH11SRC2}
	$(CC) ${COMMONSRC} ${CH11SRC2} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_13/Noise3D/CH13_Noise3D.bc: ${COMMONSRC} ${COMMONHDR} ${CH13SRC1}
	$(CC) ${COMMONSRC} ${CH13SRC1} -o ./$@ ${INCDIR} ${LIBS}
./Chapter_13/ParticleSystem/CH13_ParticleSystem.bc: ${COMMONSRC} ${COMMONHDR} ${CH13SRC2}
	$(CC) ${COMMONSRC} ${CH13SRC2} -o ./$@ ${INCDIR} ${LIBS}

=== tests/scons/SConstruct ===
env = Environment()
env.Tool('emscripten')
env.Append(CXXFLAGS='-std=c++11')
env.Program('scons_integration', ['integration.cpp', 'other.c'])

=== tests/cmake/target_html/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(hello_world_gles)

file(GLOB sourceFiles ../../hello_world_gles.c)

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	SET(linkFlags "")
else() # Either MinSizeRel, RelWithDebInfo or Release, all which run with optimizations enabled.
	SET(linkFlags "-O2")
endif()

if (NOT CMAKE_AR OR NOT EXISTS "${CMAKE_AR}")
	message(FATAL_ERROR "CMAKE_AR='${CMAKE_AR}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_RANLIB OR NOT EXISTS "${CMAKE_RANLIB}")
	message(FATAL_ERROR "CMAKE_RANLIB='${CMAKE_RANLIB}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_C_COMPILER OR NOT EXISTS "${CMAKE_C_COMPILER}")
	message(FATAL_ERROR "CMAKE_C_COMPILER='${CMAKE_C_COMPILER}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_CXX_COMPILER OR NOT EXISTS "${CMAKE_CXX_COMPILER}")
	message(FATAL_ERROR "CMAKE_CXX_COMPILER='${CMAKE_CXX_COMPILER}' does not exist for Emscripten toolchain!")
endif()

if (WIN32)
	message(FATAL_ERROR "WIN32 should not be defined when cross-compiling!")
endif()

if (APPLE)
	message(FATAL_ERROR "APPLE should not be defined when cross-compiling!")
endif()

if (NOT EMSCRIPTEN)
	message(FATAL_ERROR "EMSCRIPTEN should be defined when cross-compiling!")
endif()

if (NOT CMAKE_C_SIZEOF_DATA_PTR)
	message(FATAL_ERROR "CMAKE_C_SIZEOF_DATA_PTR was not defined!")
endif()

# with NO_DEFAULT_PATH + ONLY_CMAKE_FIND_ROOT_PATH, we ensure that
# only ${CMAKE_FIND_ROOT_PATH}/include will be searched for
# emscripten/emscripten.h
find_path(EMSCRIPTEN_INCLUDE_DIR emscripten/emscripten.h
	PATHS /include
	NO_DEFAULT_PATH
	ONLY_CMAKE_FIND_ROOT_PATH
	)

if(NOT EMSCRIPTEN_INCLUDE_DIR)
	message(FATAL_ERROR "emscripten.h could not be found! Is CMAKE_FIND_ROOT_PATH='${CMAKE_FIND_ROOT_PATH}' correct?")
endif()

include(CheckIncludeFile)

check_include_file(stdlib.h HAVE_STDLIB_H)
if (NOT ${HAVE_STDLIB_H})
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find stdlib.h via it!")
endif()

if (NOT CMAKE_EXECUTABLE_SUFFIX STREQUAL ".js")
	message(FATAL_ERROR "The default suffix for building executables should be .js!")
endif()
SET(CMAKE_EXECUTABLE_SUFFIX ".html")

# CMake built-in check_include_file() macro interacts with CMAKE_EXECUTABLE_SUFFIX, so make sure it works after user changes that.

check_include_file(math.h HAVE_MATH_H)
if (NOT ${HAVE_MATH_H})
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find math.h via it!")
endif()

add_executable(hello_world_gles ${sourceFiles})
set_target_properties(hello_world_gles PROPERTIES LINK_FLAGS "${linkFlags}")

# Validating asm.js requires SpiderMonkey JS VM - detect its presence via the SPIDERMONKEY environment variable.
if (DEFINED ENV{SPIDERMONKEY} AND CMAKE_BUILD_TYPE STREQUAL Release)
	em_validate_asmjs_after_build(hello_world_gles)
endif()

=== tests/cmake/target_js/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(test_cmake)

file(GLOB sourceFiles main.cpp)

file(GLOB preJsFiles pre*.js)
file(GLOB postJsFiles post*.js)
file(GLOB libraryJsFiles jslibrary*.js)

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	SET(linkFlags "-g4 -s NO_EXIT_RUNTIME=1")
else() # Either MinSizeRel, RelWithDebInfo or Release, all which run with optimizations enabled.
	SET(linkFlags "-O2 -s NO_EXIT_RUNTIME=1")
endif()

# Test that the CMake-provided macro check_function_exists() works.
include(CheckFunctionExists)
check_function_exists("strtod" HAVE_STRTOD)
if (NOT ${HAVE_STRTOD})
	message(FATAL_ERROR "CMake script check_function_exists failed! Could not detect if strtod() is supported!")
endif()

# Test that the CMake-provided macro check_function_exists() is not actually trivially returning true for everything.
check_function_exists("some_nonexisting_function" HAVE_NONEXISTING_FUNCTION)
if (${HAVE_NONEXISTING_FUNCTION})
	message(FATAL_ERROR "CMake script check_function_exists failed! It erroneously reports that function some_nonexisting_function() would exist!")
endif()

# Test that the CMake-provided macro check_include_file() works.
include(CheckIncludeFile)
check_include_file(stdlib.h HAVE_STDLIB_H)
if (NOT ${HAVE_STDLIB_H})
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find stdlib.h via it!")
endif()

# Test that the CMake-provided macro check_include_file() is not actually trivially returning true for everything.
check_include_file(some_nonexisting_include.h HAVE_NONEXISTING_INCLUDE_H)
if (${HAVE_NONEXISTING_INCLUDE_H})
	message(FATAL_ERROR "CMake script check_include_file failed! It erroneously reports that the C header some_nonexisting_include.h would exist!")
endif()

if (NOT CMAKE_EXECUTABLE_SUFFIX STREQUAL ".js")
	message(FATAL_ERROR "The default suffix for building executables should be .js!")
endif()

# CMake built-in check_include_file() macro interacts with CMAKE_EXECUTABLE_SUFFIX, so make sure it works after user changes that.

check_include_file(math.h HAVE_MATH_H)
if (NOT ${HAVE_MATH_H})
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find math.h via it!")
endif()

if (WIN32)
	message(FATAL_ERROR "WIN32 should not be defined when cross-compiling!")
endif()

if (APPLE)
	message(FATAL_ERROR "APPLE should not be defined when cross-compiling!")
endif()

if (NOT EMSCRIPTEN)
	message(FATAL_ERROR "EMSCRIPTEN should be defined when cross-compiling!")
endif()

if (NOT CMAKE_C_SIZEOF_DATA_PTR)
	message(FATAL_ERROR "CMAKE_C_SIZEOF_DATA_PTR was not defined!")
endif()

add_executable(test_cmake ${sourceFiles})

# GOTCHA: If your project has custom link flags, these must be set *before* calling any of the em_link_xxx functions!
set_target_properties(test_cmake PROPERTIES LINK_FLAGS "${linkFlags}")

message(STATUS "js libs '${libraryJsFiles}'")
# To link .js files using the --js-library flag, use the following helper function.
em_link_js_library(test_cmake ${libraryJsFiles})

# To link .js files using the --pre-js flag, use the following helper function.
em_link_pre_js(test_cmake ${preJsFiles})

# To link .js files using the --post-js flag, use the following helper function.
em_link_post_js(test_cmake ${postJsFiles})

=== tests/cmake/target_library/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(test_cmake)

option(BUILD_SHARED_LIBS "Build with shared libraries." OFF) 

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	SET(linkFlags "-g4")
else() # Either MinSizeRel, RelWithDebInfo or Release, all which run with optimizations enabled.
	SET(linkFlags "-O2")
endif()

set(MAX_SRC_FILE_INDEX 30)
SET(TEST_SRC_FILE_BASE_NAME "this_is_a_test_src_file_with_a_quite_lengthy_name_to_simulate_very_long_command_line_length_problems_on_windows_")


foreach(i RANGE ${MAX_SRC_FILE_INDEX})
	set (TEST_FUNCTION_NAME "FooBar_${i}")
	configure_file("srcfile.cmake" "${TEST_SRC_FILE_BASE_NAME}${i}.c")
	configure_file("srcfile.cmake" "${TEST_SRC_FILE_BASE_NAME}${i}.cpp")
	list(APPEND TEST_SOURCES "${TEST_SRC_FILE_BASE_NAME}${i}.c" "${TEST_SRC_FILE_BASE_NAME}${i}.cpp")
endforeach()

add_library(test_cmake ${TEST_SOURCES})

if (WIN32)
	message(FATAL_ERROR "WIN32 should not be defined when cross-compiling!")
endif()

if (APPLE)
	message(FATAL_ERROR "APPLE should not be defined when cross-compiling!")
endif()

if (NOT EMSCRIPTEN)
	message(FATAL_ERROR "EMSCRIPTEN should be defined when cross-compiling!")
endif()

if (NOT CMAKE_C_SIZEOF_DATA_PTR)
	message(FATAL_ERROR "CMAKE_C_SIZEOF_DATA_PTR was not defined!")
endif()

# GOTCHA: If your project has custom link flags, these must be set *before* calling any of the em_link_xxx functions!
set_target_properties(test_cmake PROPERTIES LINK_FLAGS "${linkFlags}")

=== tests/bullet/src/BulletDynamics/ibmsdk/Makefile ===
#### Source code Dirs
VPATH =				\
../ConstraintSolver		\
../Dynamics			\
../Vehicle

ROOT = ../../..

#### Library
LIBRARY_ppu = bulletdynamics.a

#### Compiler flags
CPPFLAGS        = 		\
-DUSE_LIBSPE2			\
-I../ConstraintSolver		\
-I../Dynamics			\
-I../Vehicle			\
-I$(ROOT)/src			\
-I$(SDKINC)

#### Optimization level flags
#CC_OPT_LEVEL =  $(CC_OPT_LEVEL_DEBUG)
CC_OPT_LEVEL =  -O3

##### Objects to be archived in lib

OBJS = 					\
btContactConstraint.o			\
btGeneric6DofConstraint.o		\
btHingeConstraint.o			\
btPoint2PointConstraint.o		\
btSequentialImpulseConstraintSolver.o	\
btSolve2LinearConstraint.o		\
btTypedConstraint.o			\
btDiscreteDynamicsWorld.o		\
btRigidBody.o				\
btSimpleDynamicsWorld.o			\
btRaycastVehicle.o			\
btWheelInfo.o
#### Install directories 
INSTALL_DIR	=  $(ROOT)/lib/ibmsdk
INSTALL_FILES	= $(LIBRARY_ppu)

IBM_CELLSDK_VERSION := $(shell if [ -d /opt/cell ]; then echo "3.0"; fi)

ifeq ("$(IBM_CELLSDK_VERSION)","3.0")
        CELL_TOP ?= /opt/cell/sdk
        include $(CELL_TOP)/buildutils/make.footer
else
        CELL_TOP ?= /opt/ibm/cell-sdk/prototype
        include $(CELL_TOP)/make.footer
endif

=== debian/changelog ===
emscripten (1.22.1-1build1) wily; urgency=medium

  * No-change rebuild using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 10:53:58 +0000

emscripten (1.22.1-1) unstable; urgency=medium

  * New upstream release (Closes: #748923)
  * Upstream uses now tag. Use them instead of a repack script
  * Update the clang version dependency from clang-X.Y to clang now they
    are co instalable (Closes: #748840)
  * Disable fastcomp. We don't want to manage a fork of llvm in emscripten
    and not sure we want to add this patch in llvm itself (yet).
  * Add missing sources (Closes: #753956)
  * Use node-uglify package (Closes: #753883)
  * Fix vcs-field-not-canonical

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 04 Jul 2014 13:06:38 +0200

=== debian/control ===
Source: emscripten
Section: devel
Priority: extra
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 8.0.0), python-all, help2man, node-uglify
Standards-Version: 3.9.5
Homepage: http://emscripten.org/
Vcs-Svn: svn://anonscm.debian.org/pkg-llvm/emscripten/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/emscripten/trunk/

Package: emscripten
# Not set to "any". See bug #723129
Architecture: i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf mipsel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, nodejs,
 libclosure-compiler-java, clang, llvm (>= 1:3.3), node-uglify
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web


Package: emscripten-doc
Section: doc
Depends: ${misc:Depends}
Architecture: all
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ --with python2

override_dh_install:
# Remove extra licenses
	rm -f system/include/libcxx/LICENSE.txt system/lib/compiler-rt/LICENSE.TXT system/lib/libcxx/LICENSE.txt system/lib/libcxxabi/LICENSE.TXT tests/bullet/LICENSE tests/enet/LICENSE tests/freetype/LiberationSansBoldLICENSE.txt tests/freetype/docs/LICENSE.TXT tests/openjpeg/LICENSE tests/python/LICENSE tests/sounds/LICENSE.txt tests/poppler/COPYING tests/freetype/LiberationSansBoldLICENSE.txt tests/freealut/COPYING tests/bullet/COPYING system/lib/libcxx/LICENSE.txt system/lib/libcxxabi/LICENSE.TXT tests/bullet/BulletLicense.txt system/include/SDL/COPYING tests/enet/docs/license.dox tests/box2d/License.txt tests/box2d/freeglut/COPYING tools/node_modules/source-map/LICENSE tools/node_modules/source-map/node_modules/amdefine/LICENSE tests/freetype/docs/GPL.TXT
# Remove artefact
	rm -f tools/eliminator/node_modules/uglify-js/.gitignore
# Remove Visual stuff
	rm -f `find . -iname '*.vcproj' -o -iname '*.sln' -o -iname '*.dsp' -o -iname '*.dsw'`
	chmod +x tests/embind/build_benchmark
	dh_install
	mkdir -p $(CURDIR)/debian/emscripten/usr/bin
	cd $(CURDIR)/debian/emscripten/usr/bin; \
	for f in em++ emar emcc emcc.py em-config emconfigure emmake emranlib emscripten.py emscons; do \
		ln -s ../share/emscripten/$$f; \
	done
	cd $(CURDIR)/debian/emscripten/usr/share/emscripten/tools/eliminator/node_modules/uglify-js/; \
	rm -rf lib/* bin/uglifyjs; \
	ln -s /usr/bin/uglifyjs bin/; \
	cd lib; for f in /usr/lib/nodejs/uglify-js/*; do ln -s $$f .; done

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/emscripten-$1.tar.gz/" \
 https://github.com/kripken/emscripten/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz \
debian debian/orig-tar.sh
